Bug 1391951 - Review Request: php-cs-fixer - A tool to automatically fix PHP code style
Summary: Review Request: php-cs-fixer - A tool to automatically fix PHP code style
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: François Kooman
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords: Reopened
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-11-04 13:09 UTC by Remi Collet
Modified: 2016-12-20 20:18 UTC (History)
2 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2016-12-13 22:53:15 UTC
fkooman: fedora-review+


Attachments (Terms of Use)
phpci log (77.34 KB, text/plain)
2016-11-26 18:16 UTC, François Kooman
no flags Details

Description Remi Collet 2016-11-04 13:09:06 UTC
Spec URL: https://raw.githubusercontent.com/remicollet/remirepo/master/php/php-cs-fixer/php-cs-fixer.spec
SRPM URL: http://rpms.remirepo.net/SRPMS/php-cs-fixer-1.12.3-1.remi.src.rpm
Description: 
The PHP Coding Standards Fixer tool fixes most issues in your code when you
want to follow the PHP coding standards as defined in the PSR-1 and PSR-2
documents and many more.

If you are already using a linter to identify coding standards problems in
your code, you know that fixing them by hand is tedious, especially on large
projects. This tool does not only detect them, but also fixes them for you.


Fedora Account System Username: remi



As usually, I will clean the EL-5 stuff after import

Comment 2 François Kooman 2016-11-26 18:15:09 UTC
Notes in addition to the ones "inline": 

- gh_date in the spec file seems wrong, release 1.12.4 was released much more 
  recent than the indicated gh_date.
- Group: Development/Libraries, not a library, maybe Development/Tools is more 
  appropriate
- There is still some remirepo stuff in the spec file regarding running tests, 
  is this intended? Probably not needed for Fedora?
- rpmlint complains about script intepreter: 
  php-cs-fixer.noarch: E: wrong-script-interpreter /usr/bin/php-cs-fixer /usr/bin/env php
  I guess this is a false positive?
- Maybe the self-updater should be disabled? Although it does detect it only 
  works for PHAR and then stops with error, so I guess it is fine like this :)
- rpmlint: php-cs-fixer.src: W: strange-permission makesrc.sh 775, I guess it 
  expects 755 instead...

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 412 files have
     unknown license. Detailed output of licensecheck in
     /home/fedora/1391951-php-cs-fixer/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required

**NOTE**: can be removed, but maybe not for EPEL5/6?

[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed

**NOTE**: this is also needed for EPEL5/6?

[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 81920 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Buildroot is not present
     Note: Buildroot: present but not needed

**NOTE**: this is also needed for EPEL5/6?

[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required

**NOTE**: this is also needed for EPEL5/6?

[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.

PHP:
[x]: Run phpci static analyze on all php files.
     Note: phpCompatInfo version 5.0.1 DB version 1.14.0 built Oct 17 2016
     08:05:57 CEST static analyze results in /home/fedora/1391951-php-cs-
     fixer/phpci.log


Rpmlint
-------
Checking: php-cs-fixer-1.12.4-1.fc26.noarch.rpm
          php-cs-fixer-1.12.4-1.fc26.src.rpm
php-cs-fixer.noarch: W: spelling-error %description -l en_US linter -> liner, liter, inter
php-cs-fixer.noarch: E: wrong-script-interpreter /usr/bin/php-cs-fixer /usr/bin/env php
php-cs-fixer.noarch: W: no-manual-page-for-binary php-cs-fixer
php-cs-fixer.src: W: spelling-error %description -l en_US linter -> liner, liter, inter
php-cs-fixer.src: W: strange-permission makesrc.sh 775
php-cs-fixer.src: W: invalid-url Source0: php-cs-fixer-1.12.4-c5a9d66.tgz
2 packages and 0 specfiles checked; 1 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
php-cs-fixer.noarch: W: spelling-error %description -l en_US linter -> liner, liter, inter
php-cs-fixer.noarch: E: wrong-script-interpreter /usr/bin/php-cs-fixer /usr/bin/env php
php-cs-fixer.noarch: W: no-manual-page-for-binary php-cs-fixer
1 packages and 0 specfiles checked; 1 errors, 2 warnings.



Requires
--------
php-cs-fixer (rpmlib, GLIBC filtered):
    /usr/bin/env
    php(language)
    php-cli
    php-composer(fedora/autoloader)
    php-composer(sebastian/diff)
    php-composer(symfony/console)
    php-composer(symfony/event-dispatcher)
    php-composer(symfony/filesystem)
    php-composer(symfony/finder)
    php-composer(symfony/process)
    php-composer(symfony/stopwatch)
    php-dom
    php-json
    php-pcre
    php-phar
    php-reflection
    php-spl
    php-tokenizer
    php-xml



Provides
--------
php-cs-fixer:
    php-composer(friendsofphp/php-cs-fixer)
    php-cs-fixer



Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1391951
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, PHP, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 François Kooman 2016-11-26 18:16 UTC
Created attachment 1224632 [details]
phpci log

Comment 4 Remi Collet 2016-11-26 18:31:46 UTC
(In reply to François Kooman from comment #2)
> Notes in addition to the ones "inline": 
> 
> - gh_date in the spec file seems wrong, release 1.12.4 was released much
> more 

This is only a comment ;) (only used when git snapshot are used, often for QA build)

>   recent than the indicated gh_date.
> - Group: Development/Libraries, not a library, maybe Development/Tools is
> more 
>   appropriate

Indeed

> - There is still some remirepo stuff in the spec file regarding running
> tests, 

Should not hurt

>   is this intended? Probably not needed for Fedora?

BTW, auto cleaned, with the EL-5 stuff, when spec is copied into fedora repo (cleanup commit), ex, see http://pkgs.fedoraproject.org/cgit/rpms/php-alcaeus-mongo-php-adapter.git/commit/?id=ba0e829cf42e5cc220a16afec087a8c4c599cd57

I just keep them to avoid having to maintain 2 versions of the spec file between review submission and approval.

> - rpmlint complains about script intepreter: 
>   php-cs-fixer.noarch: E: wrong-script-interpreter /usr/bin/php-cs-fixer
> /usr/bin/env php
>   I guess this is a false positive?

Yes, this is deliberate.
Nothing in Guidelines forbid the use of /usr/bin/env in shebang, and BTW, this allow to work with Software Collections (ok, mostly useful in EPEL)

And php-cli is properly required.


> - Maybe the self-updater should be disabled? Although it does detect it only 
>   works for PHAR and then stops with error, so I guess it is fine like this
> :)

Indeed.

> - rpmlint: php-cs-fixer.src: W: strange-permission makesrc.sh 775, I guess
> it 
>   expects 755 instead...

No, 755 raise the same rpmlint warning. False positive IMHO.
This "source" need to be executable (and not used during the build)

Comment 5 Remi Collet 2016-11-26 18:35:11 UTC
Fix for the Group: https://github.com/remicollet/remirepo/commit/0a903e5cbb230e5bad311bd02ed8d647b89345b7

Spec: https://raw.githubusercontent.com/remicollet/remirepo/0a903e5cbb230e5bad311bd02ed8d647b89345b7/php/php-cs-fixer/php-cs-fixer.spec
Srpm: http://rpms.remirepo.net/SRPMS/php-cs-fixer-1.12.4-1.remi.src.rpm

I really you prefer me to run the cleanup (EL-5 stuff + #remirepo part) I can do it, but I don't think this should be a blocker.

Comment 6 François Kooman 2016-11-27 10:52:24 UTC
No, the remirepo stuff can stay, I don't really mind, especially if you want to make it available on EL5/EL6 and SC. 

Approved.

Comment 7 Remi Collet 2016-11-27 10:57:45 UTC
Thanks for the review.

New package requested on pkgdb.

Comment 8 Gwyn Ciesla 2016-11-28 14:21:34 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/php-cs-fixer

Comment 9 Fedora Update System 2016-11-28 16:06:06 UTC
php-cs-fixer-1.12.4-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-eff2120f31

Comment 10 Fedora Update System 2016-11-28 16:06:14 UTC
php-cs-fixer-1.12.4-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-b4836e981b

Comment 11 Fedora Update System 2016-11-28 16:06:19 UTC
php-cs-fixer-1.12.4-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-0f90e4d0d8

Comment 12 Remi Collet 2016-11-29 12:54:15 UTC
>  - Maybe the self-updater should be disabled? 

I think this should go upstream, so:
https://github.com/FriendsOfPHP/PHP-CS-Fixer/pull/2335

Comment 13 Fedora Update System 2016-11-30 05:51:26 UTC
php-cs-fixer-1.13.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-0f90e4d0d8

Comment 14 Fedora Update System 2016-12-02 06:27:07 UTC
php-cs-fixer-1.13.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-eff2120f31

Comment 15 Fedora Update System 2016-12-02 18:54:34 UTC
php-cs-fixer-1.13.0-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-b4836e981b

Comment 16 Fedora Update System 2016-12-04 02:25:06 UTC
php-cs-fixer-1.13.0-1.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2016-12-05 07:29:18 UTC
php-cs-fixer-2.0.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-0f90e4d0d8

Comment 18 Fedora Update System 2016-12-05 07:29:36 UTC
php-cs-fixer-2.0.0-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-eff2120f31

Comment 19 Fedora Update System 2016-12-06 03:59:13 UTC
php-cs-fixer-2.0.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-eff2120f31

Comment 20 Fedora Update System 2016-12-06 04:21:09 UTC
php-cs-fixer-2.0.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-0f90e4d0d8

Comment 21 Fedora Update System 2016-12-13 22:53:15 UTC
php-cs-fixer-2.0.0-1.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2016-12-20 20:18:00 UTC
php-cs-fixer-2.0.0-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.